      subroutine cg2cll(stcprm, alat,along, ug,vg, ue,vn)

	include 'cmapf.fi'
      real stcprm(k_mparam)

      real norm
      call cpolll(stcprm, alat,along ,enx,eny,enz)
      norm = sqrt(enx*enx + eny*eny)
      if (norm .le. .1e-3) then
        csx = cos(RADPDG*along)
        sny = sin(RADPDG*along)
        call cgrnll(stcprm, alat,along, gnx,gny,gnz)
        if (enz .gt. 0.) then
C  (gnx,gny) is the direction of Greenwich Meridian, (-gny,gnx) is
C  the direction of the 90E meridian.  "North" is the direction
C  toward the North pole along the along meridian.
          enx = - csx * gnx + sny * gny
          eny = - csx * gny - sny * gnx
        else
C  (gnx,gny) is the direction of Greenwich Meridian, (gny,-gnx) is
C  the direction of the 90E meridian.  "North" is the direction
C  away from the South pole along the along meridian.
          enx = csx * gnx + sny * gny
          eny = csx * gny - sny * gnx
        endif
      else
        enx = enx / norm
        eny = eny / norm
      endif
      ue = - enx * vg + eny * ug
      vn = eny * vg + enx * ug
      return
      end

      subroutine cg2wll(stcprm, alat,along, ug,vg, ue,vn)

	include 'cmapf.fi'
      real stcprm(k_mparam)

      parameter (sin1dg=.017452406437284)
      real norm
      call cpolll(stcprm, alat,along ,enx,eny,enz)
      norm = sqrt(enx*enx + eny*eny)
      if (norm .le. SIN1DG) then
        call cgrnll(stcprm, alat,along, enx,eny,enz)
        norm = sqrt(enx*enx + eny*eny)
      endif
      enx = enx / norm
      eny = eny / norm
      ue = - enx * vg + eny * ug
      vn = eny * vg + enx * ug
      return
      end
