      subroutine ll_geo(xlat, xlong, vector)
C  Given a latitude xlat and longitude xlong, returns the unit vector
C  directed to the given point in the geo (geographic) coordinate system.
C
C  The geo system is a 3-D Cartesian coordinate system, with origin
C  at the Center of the Earth, with the x_3 axis pointing to the North
C  Pole, the x_1 axis pointing to the Equator at the Greenwich Meridian,
C  and the x_2 axis by the right hand rule pointing to the Equator
C  at 90 E.

	include 'cmapf.fi'

      dimension vector(3)
        vector(3) = sin(RADPDG * xlat)
        clat = cos(RADPDG * xlat)
        vector(1) = clat * cos(RADPDG * xlong)
        vector(2) = clat * sin(RADPDG * xlong)
      return
      end
