      subroutine sobmrc(stcprm, r_lat, r_long, an_lat, an_lng)
C/*
C *  Set Map Parameters for an Oblique MeRCator Projection
C *  Inputs: r_lat,r_long - latitude and longitude of reference
C *            point on the great circle tangent to the cylinder,
C *            and 180 degrees from the cut.
C *       an_lat,an_lng - latitude and longitude of
C *            an anchor point elsewhere on the same great circle.
C *  Outputs: stcprm - map parameters
C */

	include 'cmapf.fi'
      real stcprm(k_mparam)

      real refpnt(3),anchpt(3),prjpol(3)
      real*8  p_lat,p_long,norm
      call ll_geo(r_lat,r_long,refpnt)
      call ll_geo(an_lat,an_lng,anchpt)
      norm = x_prod(anchpt,refpnt,prjpol)
      if (norm .ne. 0.) then
        call geo_ll(prjpol,p_lat,p_long)
        call mpstrt(stcprm, 0., p_lat,p_long, r_lat,r_long)
      else
        call stvmrc(stcprm, r_lat, r_long)
      endif
      return
      end
