      subroutine xy_map(stcprm, x,y, map)

	include 'cmapf.fi'
      real stcprm(k_mparam)

      real map(3)
      real lnabva
        xi0 = (x - stcprm(k_x0)) * stcprm(k_gdszeq) / stcprm(k_ertrad)
        eta0 = (y - stcprm(k_y0)) * stcprm(k_gdszeq) / stcprm(k_ertrad)
        xi = xi0 * stcprm(k_crot) - eta0 * stcprm(k_srot)
        eta = xi0 * stcprm(k_srot) + eta0 * stcprm(k_crot)
        vsq = stcprm(k_gama) * (xi*xi + eta*eta) - 2. * eta
        if (stcprm(k_gama) * vsq + 1. .le. 3.e-8) then
C/* Case of point at Projection Pole */
          map(1) = 0.
          map(2) = 0.
          map(3) = sign(1.,stcprm(k_gama))
        else
          if ( stcprm(k_gama) .ge. 1.) then
C/* Stereographic Case, std */
            fact = 2. / (2. + vsq)
            map(2) = xi * fact
            map(1) = (1. - eta) * fact
            map(3) = fact - 1.
          else if (stcprm(k_gama) .le. -1.) then
C/* Stereographic Case, centered at antipodes */
            fact = -2. / (2. - vsq)
            map(2) = xi * fact
            map(1) = (- 1. - eta) * fact
            map(3) = fact + 1.
          else
C/* Mercator or Lambert Case */
            ymerc = -.5 * lnabva(stcprm(k_gama), vsq)
            if ( ymerc .gt. 0.) then
              fact = exp(-ymerc)
              cosphi = fact / (1. + fact * fact)
              cosphi = cosphi + cosphi
              map(3) = 1. - fact * cosphi
            else
              fact = exp(ymerc)
              cosphi = fact / (1. + fact * fact)
              cosphi = cosphi + cosphi
              map(3) = fact * cosphi - 1.
            endif
C/*      map.v[2] = 1. - fact * cosphi; */
            if (abs(map(3)) .lt. 1.) then
              theta = atnabv(stcprm(k_gama), xi, eta)
              map(1) = cosphi * cos(theta)
              map(2) = cosphi * sin(theta)
            else
              map(1) = 0.
              map(2) = 0.
            endif
          endif
        endif
      return
      end
